import { ControlElement } from "./ControlElement";
import { Complex } from "Framework/Math/Complex";
export declare class ControlComparator extends ControlElement {
    private _Threshold;
    private _uMin;
    private _uMax;
    private _time;
    private _direction;
    private _lastTime;
    private _period;
    private _periodCnt;
    readonly Period: number;
    readonly Amplitude: number;
    constructor(threshold: number, uMin: number, uMax: number);
    GetType(): string;
    GetLowestTimeConstant(): number;
    Initialize(_dt: number): void;
    Calculate(e: number, dt: number): number;
    TimeFunctionStepResponse(_t: number): number;
    private _res;
    TransferFunction(_s: Complex): Complex;
    OptimizeGetNumParameters(): number;
    OptimizeSetParameters(params: number[], startIdx: number): void;
}
