import { IControlOptimization } from "./IControlOptimization";
import { Complex } from "Framework/Math/Complex";
export declare abstract class ControlElement implements IControlOptimization {
    abstract GetType(): string;
    abstract GetLowestTimeConstant(): number;
    abstract Initialize(dt: number): void;
    abstract Calculate(input: number, dt: number): number;
    abstract OptimizeGetNumParameters(): number;
    abstract OptimizeSetParameters(params: number[], startIdx: number): void;
    abstract TimeFunctionStepResponse(t: number): number;
    abstract TransferFunction(s: Complex): Complex;
    static GetTransferFunctionLatex(func: string): string;
    static GetStepResponseLatex(func: string): string;
    private static readonly TRANSFER_FUNCTION;
    private static readonly STEP_RESPONSE;
}
