import { ControlElement } from "./ControlElement";
import { Complex } from "Framework/Math/Complex";
export declare class ControlPID extends ControlElement {
    private _Kp;
    private _Ki;
    private _Kd;
    private readonly _uMin;
    private readonly _uMax;
    private _e_n1;
    private _e_sum;
    constructor(Kp: number, Ki: number, Kd: number, uMin: number, uMax: number);
    GetType(): string;
    GetLowestTimeConstant(): number;
    Initialize(_dt: number): void;
    Calculate(e: number, dt: number): number;
    TimeFunctionStepResponse(t: number): number;
    private _res;
    private _tmp;
    TransferFunction(s: Complex): Complex;
    OptimizeGetNumParameters(): number;
    OptimizeSetParameters(params: number[], startIdx: number): void;
}
