import { ControlLoop } from "./ControlLoop";
import { IControlOptimization } from "./IControlOptimization";
import { IDifferentialEvolutionRating } from "Framework/DifferentialEvolution/IDifferentialEvolutionRating";
export declare class ControllerOptimizationDifferentialEvolution implements IDifferentialEvolutionRating {
    private readonly _NUM_TIME_STEPS;
    private _controlLoop;
    private _controlOptimization;
    private _stepHeight;
    private _stepTime;
    private _endTime;
    private _calcError;
    constructor(controlLoop: ControlLoop, controlOptimization: IControlOptimization);
    Optimize(limitMinParams: number, limitMaxParams: number, dither: boolean, maxNumSteps: number, stepHeight: number, stepTime: number, endTime: number, maxOvershot: number, weightingCtrlOut: number, weightingOvershot: number): number[];
    RateCandidate(paramList: number[]): number;
    private Evaluate(params, stepHeight, stepTime, endTime);
}
