var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ControlElement } from "./ControlElement";
import { Complex } from "../../Framework/Math/Complex";
var ControlElementD = (function (_super) {
    __extends(ControlElementD, _super);
    function ControlElementD(K) {
        var _this = _super.call(this) || this;
        _this._u_n1 = 0;
        _this._res = new Complex(0);
        _this._K = K;
        return _this;
    }
    ControlElementD.prototype.GetType = function () {
        return "D";
    };
    ControlElementD.prototype.GetLowestTimeConstant = function () {
        return -1;
    };
    ControlElementD.prototype.Initialize = function (_dt) {
        this._u_n1 = 0;
    };
    ControlElementD.prototype.Calculate = function (u, dt) {
        var y = this._K * (u - this._u_n1) / dt;
        this._u_n1 = u;
        return y;
    };
    ControlElementD.prototype.TimeFunctionStepResponse = function (t) {
        var n = 10;
        var d = n * Math.exp(-Math.PI * n * n * t * t);
        return d;
    };
    ControlElementD.prototype.TransferFunction = function (s) {
        this._res.Copy(s);
        this._res.MulR(this._K);
        return this._res;
    };
    ControlElementD.prototype.OptimizeGetNumParameters = function () {
        return 1;
    };
    ControlElementD.prototype.OptimizeSetParameters = function (params, startIdx) {
        this._K = params[startIdx + 0];
    };
    return ControlElementD;
}(ControlElement));
export { ControlElementD };
//# sourceMappingURL=ControlElementD.js.map