import { Gui } from "Framework/Gui/Gui";
import { GuiControlElement } from "./GuiControlElement";
import { ControlPath } from "./ControlPath";
var ControlApp = (function () {
    function ControlApp() {
        this.MAX_NUM_CONTROL_ELEMENTS = 4;
        var idx;
        this._controlPathImg = document.getElementById("PIC_CTRL");
        this._controlElementList = [];
        for (idx = 1; idx <= this.MAX_NUM_CONTROL_ELEMENTS; idx++)
            this._controlElementList[idx] = GuiControlElement.Create("NONE", idx, this._controlPathImg);
    }
    ControlApp.prototype.InitGui = function () {
        var idx;
        for (idx = 1; idx <= this.MAX_NUM_CONTROL_ELEMENTS; idx++) {
            this.CtrlElemSelected(idx);
        }
    };
    ControlApp.prototype.CreateControlPathFromGui = function () {
        var ctrlPath = new ControlPath();
        var idx;
        for (idx = 1; idx <= this.MAX_NUM_CONTROL_ELEMENTS; idx++) {
            if (this._controlElementList[idx].CtrlType != "NONE")
                ctrlPath.Add(this._controlElementList[idx].CreateControl());
        }
        return ctrlPath;
    };
    ControlApp.prototype.ShowControlParamsInGui = function (ctrlParams) {
        var idx;
        var paramIdx = 0;
        for (idx = 1; idx <= this.MAX_NUM_CONTROL_ELEMENTS; idx++) {
            if (this._controlElementList[idx].CtrlType != "NONE")
                this._controlElementList[idx].ShowParamVals(ctrlParams, paramIdx);
            paramIdx += this._controlElementList[idx].GetNumParams();
        }
    };
    ControlApp.prototype.SetControlParamInGuiPic = function (paramName, valStr) {
        this._controlPathImg.contentDocument.getElementById(paramName).textContent = valStr;
    };
    ControlApp.prototype.CtrlElemSelected = function (idx) {
        var ctrlType = Gui.GetString("CTRL_ELEM_TYPE_" + idx);
        var ctrl = GuiControlElement.Create(ctrlType, idx, this._controlPathImg);
        this._controlElementList[idx] = ctrl;
        ctrl.Show();
        ctrl.ShowParams();
    };
    return ControlApp;
}());
export { ControlApp };
//# sourceMappingURL=ControlApp.js.map