var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Gui } from "Framework/Gui/Gui";
import { Graph } from "Framework/Gui/Graph";
import { ControlApp } from "./ControlApp";
import { ControlTools } from "./ControlTools";
import { ControlLoop } from "./ControlLoop";
import { ControlSimulation } from "./ControlSimulation";
import { ControlPID } from "./ControlPID";
var ControlApp_ControlLoopTuningStepResponse = (function (_super) {
    __extends(ControlApp_ControlLoopTuningStepResponse, _super);
    function ControlApp_ControlLoopTuningStepResponse() {
        var _this = _super.call(this) || this;
        _this._ctrlLoopStepTuningPidVals = {};
        return _this;
    }
    ControlApp_ControlLoopTuningStepResponse.prototype.ControlLoopTuningStepResponse = function (graphId) {
        var X = 0;
        var Y = 1;
        try {
            var stepHeight = Gui.GetNumber("STEP_HEIGHT");
            var stepTime = Gui.GetNumber("STEP_TIME");
            var endTime = Gui.GetNumber("END_TIME");
            var ctrlPath = this.CreateControlPathFromGui();
            var ctrlSim = new ControlSimulation(ctrlPath);
            var curveU = void 0;
            var curveY = void 0;
            _a = ctrlSim.StepResponseControlPath(stepHeight, stepTime, endTime), curveU = _a[0], curveY = _a[1];
            var m = void 0;
            var n = void 0;
            _b = ControlTools.GetInflectionTangent(curveY, stepTime), m = _b[0], n = _b[1];
            var y0 = 0;
            var x0 = -n / m;
            var ye = curveY[curveY.length - 1][Y];
            var xe = (ye - n) / m;
            var curveT = [[x0, y0], [xe, ye]];
            var curveTg = [[xe, 0], [xe, ye]];
            var curveTu = [[x0, 0], [x0, ye]];
            var curveDX = [[0, ye], [curveY[curveY.length - 1][X], ye]];
            Graph.Draw(graphId, "Step response", "Time", "Amplitude", "Amplitude", ["u(t)", "y(t)", "tangent", "Tg", "Tu", "dX"], [1, 1, 1, 1, 1, 1], ["#0000FF", "#FF0000", "#00FF00", "#555555", "#777777", "#999999"], [curveU, curveY, curveT, curveTg, curveTu, curveDX]);
            var ks = ye - y0;
            var tu = x0 - stepTime;
            var tg = xe - x0;
            Gui.SetTableCell("TABLE_PATH_PARAM", 1, 2, ks.toPrecision(4));
            Gui.SetTableCell("TABLE_PATH_PARAM", 2, 2, tu.toPrecision(4));
            Gui.SetTableCell("TABLE_PATH_PARAM", 3, 2, tg.toPrecision(4));
            this.CalcPidParamTable(ks, tu, tg);
        }
        catch (err) {
            alert(err.message);
        }
        var _a, _b;
    };
    ControlApp_ControlLoopTuningStepResponse.prototype.CalcPidParamTable = function (ks, tu, tg) {
        this._ctrlLoopStepTuningPidVals["ZN_P"] = [1.0 * tg / (ks * tu), 0, 0];
        this._ctrlLoopStepTuningPidVals["ZN_PI"] = [0.9 * tg / (ks * tu), 0.273 * tg / (ks * tu * tu), 0];
        this._ctrlLoopStepTuningPidVals["ZN_PID"] = [1.2 * tg / (ks * tu), 0.6 * tg / (ks * tu * tu), 0.6 * tg / ks];
        this._ctrlLoopStepTuningPidVals["CHR_P"] = [0.3 * tg / (ks * tu), 0, 0];
        this._ctrlLoopStepTuningPidVals["CHR_PI"] = [0.35 * tg / (ks * tu), 0.292 / (ks * tu), 0];
        this._ctrlLoopStepTuningPidVals["CHR_PID"] = [0.6 * tg / (ks * tu), 0.6 / (ks * tu), 0.3 * tg / ks];
        Gui.SetTableCell("TABLE_PID_PARAM", 1, 1, this._ctrlLoopStepTuningPidVals["ZN_P"][0].toPrecision(4));
        Gui.SetTableCell("TABLE_PID_PARAM", 2, 1, this._ctrlLoopStepTuningPidVals["ZN_PI"][0].toPrecision(4));
        Gui.SetTableCell("TABLE_PID_PARAM", 2, 2, this._ctrlLoopStepTuningPidVals["ZN_PI"][1].toPrecision(4));
        Gui.SetTableCell("TABLE_PID_PARAM", 3, 1, this._ctrlLoopStepTuningPidVals["ZN_PID"][0].toPrecision(4));
        Gui.SetTableCell("TABLE_PID_PARAM", 3, 2, this._ctrlLoopStepTuningPidVals["ZN_PID"][1].toPrecision(4));
        Gui.SetTableCell("TABLE_PID_PARAM", 3, 3, this._ctrlLoopStepTuningPidVals["ZN_PID"][2].toPrecision(4));
        Gui.SetTableCell("TABLE_PID_PARAM", 4, 1, this._ctrlLoopStepTuningPidVals["CHR_P"][0].toPrecision(4));
        Gui.SetTableCell("TABLE_PID_PARAM", 5, 1, this._ctrlLoopStepTuningPidVals["CHR_PI"][0].toPrecision(4));
        Gui.SetTableCell("TABLE_PID_PARAM", 5, 2, this._ctrlLoopStepTuningPidVals["CHR_PI"][1].toPrecision(4));
        Gui.SetTableCell("TABLE_PID_PARAM", 6, 1, this._ctrlLoopStepTuningPidVals["CHR_PID"][0].toPrecision(4));
        Gui.SetTableCell("TABLE_PID_PARAM", 6, 2, this._ctrlLoopStepTuningPidVals["CHR_PID"][1].toPrecision(4));
        Gui.SetTableCell("TABLE_PID_PARAM", 6, 3, this._ctrlLoopStepTuningPidVals["CHR_PID"][2].toPrecision(4));
    };
    ControlApp_ControlLoopTuningStepResponse.prototype.ControlLoopTuningDrawStepResponse = function (graphId) {
        try {
            var method = Gui.GetCheckedRadioValue("PID_VALS");
            var pidKp = this._ctrlLoopStepTuningPidVals[method][0];
            var pidKi = this._ctrlLoopStepTuningPidVals[method][1];
            var pidKd = this._ctrlLoopStepTuningPidVals[method][2];
            var pidUMin = Gui.GetNumber("PID_U_MIN");
            var pidUMax = Gui.GetNumber("PID_U_MAX");
            var stepHeight = Gui.GetNumber("STEP_HEIGHT");
            var stepTime = Gui.GetNumber("STEP_TIME");
            var endTime = Gui.GetNumber("END_TIME");
            this.SetControlParamInGuiPic("PID_CTRL_1_KP", "Kp = " + pidKp.toPrecision(3));
            this.SetControlParamInGuiPic("PID_CTRL_1_KI", "Ki = " + pidKi.toPrecision(3));
            this.SetControlParamInGuiPic("PID_CTRL_1_KD", "Kd = " + pidKd.toPrecision(3));
            var ctrlPath = this.CreateControlPathFromGui();
            var ctrlPid = new ControlPID(pidKp, pidKi, pidKd, pidUMin, pidUMax);
            var ctrlLoop = new ControlLoop(ctrlPid, ctrlPath);
            var ctrlSim = new ControlSimulation(ctrlLoop);
            var curveW = void 0;
            var curveU = void 0;
            var curveY = void 0;
            var maxY = void 0;
            _a = ctrlSim.StepResponseControlLoop(stepHeight, stepTime, endTime), curveW = _a[0], curveU = _a[1], curveY = _a[2], maxY = _a[3];
            var curveNameList = ["u(t)", "w(t)", "y(t)"];
            var yAxisList = [2, 1, 1];
            var curveColorList = ["#00FF00", "#0000FF", "#FF0000"];
            var curveDataList = [curveU, curveW, curveY];
            Graph.Draw(graphId, "Step response", "Time", "Amplitude", "Amplitude", curveNameList, yAxisList, curveColorList, curveDataList);
            var overshotPercent = (maxY - stepHeight) / stepHeight * 100;
            document.getElementById("OVERSHOT").textContent = "Überschwingen: " + overshotPercent.toFixed(2) + "%";
        }
        catch (err) {
            alert(err.message);
        }
        var _a;
    };
    return ControlApp_ControlLoopTuningStepResponse;
}(ControlApp));
export { ControlApp_ControlLoopTuningStepResponse };
//# sourceMappingURL=ControlApp_ControlLoopTuningStepResponse.js.map