var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Gui } from "Framework/Gui/Gui";
import { Graph } from "Framework/Gui/Graph";
import { Derivative } from "Framework/Math/Derivative";
import { ControlApp } from "./ControlApp";
import { ControlSimulation } from "./ControlSimulation";
var ControlApp_ControlPathStepResponse = (function (_super) {
    __extends(ControlApp_ControlPathStepResponse, _super);
    function ControlApp_ControlPathStepResponse() {
        return _super.call(this) || this;
    }
    ControlApp_ControlPathStepResponse.prototype.ControlPathStepResponse = function (measuredData) {
        try {
            var stepHeight = Gui.GetNumber("STEP_HEIGHT");
            var stepTime = Gui.GetNumber("STEP_TIME");
            var endTime = Gui.GetNumber("END_TIME");
            var show1stDerivative = Gui.IsCheckedWithDefault("SHOW_DERIVATIVE_1", false);
            var show2ndDerivative = Gui.IsCheckedWithDefault("SHOW_DERIVATIVE_2", false);
            var ctrlPath = this.CreateControlPathFromGui();
            var ctrlSim = new ControlSimulation(ctrlPath);
            var curveU = void 0;
            var curveY = void 0;
            _a = ctrlSim.StepResponseControlPath(stepHeight, stepTime, endTime), curveU = _a[0], curveY = _a[1];
            var curveNameList = ["u(t)", "y(t)"];
            var yAxisList = [1, 1];
            var curveColorList = ["#0000FF", "#FF0000"];
            var curveDataList = [curveU, curveY];
            if (measuredData) {
                curveNameList.push("measured(t)");
                yAxisList.push(1);
                curveColorList.push("#00FF00");
                curveDataList.push(measuredData);
            }
            if (show1stDerivative) {
                var curveDy1 = Derivative.DerivativeEx(curveY);
                curveNameList.push("1st derivative y(t)");
                yAxisList.push(1);
                curveColorList.push("#9400D3");
                curveDataList.push(curveDy1);
            }
            if (show2ndDerivative) {
                var curveDy1 = Derivative.DerivativeEx(curveY);
                var curveDy2 = Derivative.DerivativeEx(curveDy1);
                curveNameList.push("2nd derivative y(t)");
                yAxisList.push(1);
                curveColorList.push("#4B0082");
                curveDataList.push(curveDy2);
            }
            Graph.Draw("DIV_GRAPH", "Step response", "Time", "Amplitude", "Amplitude", curveNameList, yAxisList, curveColorList, curveDataList);
        }
        catch (err) {
            alert(err.message);
        }
        var _a;
    };
    return ControlApp_ControlPathStepResponse;
}(ControlApp));
export { ControlApp_ControlPathStepResponse };
//# sourceMappingURL=ControlApp_ControlPathStepResponse.js.map