var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ControlElement } from "./ControlElement";
import { Complex } from "Framework/Math/Complex";
var ControlComparator = (function (_super) {
    __extends(ControlComparator, _super);
    function ControlComparator(threshold, uMin, uMax) {
        var _this = _super.call(this) || this;
        _this._res = new Complex(0);
        _this._Threshold = threshold;
        _this._uMin = uMin;
        _this._uMax = uMax;
        return _this;
    }
    Object.defineProperty(ControlComparator.prototype, "Period", {
        get: function () { return this._period / this._periodCnt; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ControlComparator.prototype, "Amplitude", {
        get: function () { return (this._uMax - this._uMin) / 2; },
        enumerable: true,
        configurable: true
    });
    ControlComparator.prototype.GetType = function () {
        return "Comparator";
    };
    ControlComparator.prototype.GetLowestTimeConstant = function () {
        return -1;
    };
    ControlComparator.prototype.Initialize = function (_dt) {
        this._time = 0;
        this._direction = 0;
        this._lastTime = -1;
        this._period = 0;
        this._periodCnt = 0;
    };
    ControlComparator.prototype.Calculate = function (e, dt) {
        var u;
        this._time += dt;
        if (e + this._Threshold > 0) {
            if (this._direction == -1) {
                if (this._lastTime >= 0) {
                    this._period += this._time - this._lastTime;
                    this._periodCnt++;
                }
                this._lastTime = this._time;
            }
            u = this._uMax;
            this._direction = 1;
        }
        else {
            u = this._uMin;
            this._direction = -1;
        }
        return u;
    };
    ControlComparator.prototype.TimeFunctionStepResponse = function (_t) {
        return 0;
    };
    ControlComparator.prototype.TransferFunction = function (_s) {
        this._res.Set(0, 0);
        return this._res;
    };
    ControlComparator.prototype.OptimizeGetNumParameters = function () {
        return 3;
    };
    ControlComparator.prototype.OptimizeSetParameters = function (params, startIdx) {
        this._Threshold = params[startIdx + 0];
        this._uMin = params[startIdx + 1];
        this._uMax = params[startIdx + 2];
    };
    return ControlComparator;
}(ControlElement));
export { ControlComparator };
//# sourceMappingURL=ControlComparator.js.map