var ControlElement = (function () {
    function ControlElement() {
    }
    ControlElement.GetTransferFunctionLatex = function (func) {
        if (func in this.TRANSFER_FUNCTION)
            return this.TRANSFER_FUNCTION[func];
        else
            return "";
    };
    ControlElement.GetStepResponseLatex = function (func) {
        if (func in this.STEP_RESPONSE)
            return this.STEP_RESPONSE[func];
        else
            return "";
    };
    ControlElement.TRANSFER_FUNCTION = {
        "P": "K",
        "I": "\\frac{1}{T \\cdot s}",
        "D": "T \\cdot s",
        "PT1": "\\frac{K}{1 + T \\cdot s}",
        "PT2": "\\frac{K}{1 + 2 \\cdot D \\cdot T \\cdot s + T^2 \\cdot s^2}",
        "PD1": "K \\cdot (1 + T \\cdot s)",
        "DeadTime": "e^{-s \\cdot T}",
        "PID": "K_P+\\frac{K_I}{s}+K_D \\cdot s"
    };
    ControlElement.STEP_RESPONSE = {
        "P": "f(t) = K",
        "I": "f(t) = \\frac{t}{T}",
        "D": "f(t) = T \\cdot \\delta (t)",
        "PT1": "f(t) = K (1 - e^{\\frac{-t}{T}})",
        "PD1": "f(t) = K ( T \\cdot \\delta(t)+1)",
        "DeadTime": "f(t) = \\Theta (t - T)",
        "PID": "f(t) = K_P + K_I \\cdot t + K_D \\cdot \\delta (t)",
        "PT2": "\\begin{align} A &= (D^2-1)T^2 \\\\ f(t) &= K(1-\\frac{\\sqrt{A}}{2 A}((\\sqrt{A}-D T) e^{t(-\\frac{\\sqrt{A}}{T^2}-\\frac{D}{T})} + (\\sqrt{A} + D T) e^{t(\\frac{\\sqrt{A}}{T^2}-\\frac{D}{T})} )) \\end{align}"
    };
    return ControlElement;
}());
export { ControlElement };
//# sourceMappingURL=ControlElement.js.map