import { Gui } from "Framework/Gui/Gui";
var TransferFunction = (function () {
    function TransferFunction(formula) {
        this._code = math.compile(formula);
    }
    TransferFunction.prototype.Function = function (sVal) {
        var scope = { s: sVal };
        return this._code.eval(scope);
    };
    return TransferFunction;
}());
var ControlPathFormulaSim = (function () {
    function ControlPathFormulaSim() {
    }
    ControlPathFormulaSim.prototype.ControlPathStepResponse = function () {
        try {
            var formulaControllerElem = document.getElementById("formula_controller");
            var formulaControlPathElem = document.getElementById("formula_control_path");
            var formulaController = Gui.GetString("input_controller");
            var formulaControlPath = Gui.GetString("input_control_path");
            formulaControllerElem.textContent = "$$" + formulaController + "$$";
            formulaControlPathElem.textContent = "$$" + formulaControlPath + "$$";
            MathJax.Hub.Queue(["Typeset", MathJax.Hub, formulaControllerElem]);
            MathJax.Hub.Queue(["Typeset", MathJax.Hub, formulaControlPathElem]);
            var funcCtrl = new TransferFunction(formulaController);
            var funcCtrlPath = new TransferFunction(formulaControlPath);
            var gs = ControlPathFormulaSim.FuncClosedLoop(1, funcCtrl, funcCtrlPath);
            console.log(gs);
        }
        catch (err) {
            alert(err.message);
        }
    };
    ControlPathFormulaSim.FuncStep = function (s, stepHeight) {
        return stepHeight / s;
    };
    ControlPathFormulaSim.FuncClosedLoop = function (s, controler, controlPath) {
        var g = controler.Function(s) * controlPath.Function(s);
        return g / (1 + g);
    };
    return ControlPathFormulaSim;
}());
export { ControlPathFormulaSim };
//# sourceMappingURL=ControlPathFormulaSim.js.map