var ControlOptimizationError = (function () {
    function ControlOptimizationError(controlLoop, stepHeight, maxOvershot, weightingCtrlOut, weightingOvershot) {
        this._controlLoop = controlLoop;
        this._stepHeight = stepHeight;
        this._maxOvershot = maxOvershot;
        this._weightingCtrlOut = weightingCtrlOut;
        this._weightingOvershot = weightingOvershot;
    }
    ControlOptimizationError.prototype.CalcError = function (w, y) {
        var dy = w - y;
        var e = dy * dy;
        if (this._controlLoop.U > this._stepHeight) {
            var du = this._controlLoop.U - this._stepHeight;
            e += du * du * this._weightingCtrlOut;
        }
        if (y > this._stepHeight + this._maxOvershot) {
            var dd = y - (this._stepHeight + this._maxOvershot);
            e += dd * dd * this._weightingOvershot;
        }
        return e;
    };
    return ControlOptimizationError;
}());
export { ControlOptimizationError };
//# sourceMappingURL=ControlOptimizationError.js.map