import { Complex } from "./Complex";
var LaplaceTransformInversionZakian = (function () {
    function LaplaceTransformInversionZakian() {
        this._a = [
            new Complex(12.83767675, 1.666063445),
            new Complex(12.22613209, 5.012718792),
            new Complex(10.93430308, 8.409673116),
            new Complex(8.776434715, 11.92185389),
            new Complex(5.225453361, 15.72952905)
        ];
        this._k = [
            new Complex(-36902.08210, 196990.4257),
            new Complex(61277.02524, -95408.62551),
            new Complex(-28916.56288, 18169.18531),
            new Complex(4655.361138, -1.901528642),
            new Complex(-118.7414011, -141.3036911)
        ];
    }
    LaplaceTransformInversionZakian.prototype.GetName = function () { return "Zakian"; };
    LaplaceTransformInversionZakian.prototype.Calculate = function (F, tArr) {
        var yArr = [];
        var idx;
        var c = new Complex();
        for (idx = 0; idx < tArr.length; idx++) {
            var t = tArr[idx];
            if (t <= 0) {
                yArr[idx] = 0;
                continue;
            }
            var sum = 0;
            var i = void 0;
            for (i = 0; i < 5; i++) {
                c.Copy(this._a[i]);
                c.DivR(t);
                c.Copy(F.Function(c));
                c.Mul(this._k[i]);
                sum += c.Real;
            }
            yArr[idx] = 2 * sum / t;
        }
        return yArr;
    };
    return LaplaceTransformInversionZakian;
}());
export { LaplaceTransformInversionZakian };
//# sourceMappingURL=LaplaceTransformInversionZakian.js.map