var Derivative = (function () {
    function Derivative() {
    }
    Derivative.Derivative = function (x, y) {
        if (x.length <= 1)
            throw new Error("Derivative: number of values must be greater than 1");
        if (x.length != y.length)
            throw new Error("Derivative: number of x and y values must be equal");
        var d = [];
        var idx;
        var sz = x.length - 1;
        d[0] = (y[1] - y[0]) / (x[1] - x[0]);
        d[sz] = (y[sz] - y[sz - 1]) / (x[sz] - x[sz - 1]);
        for (idx = 1; idx < sz; idx++) {
            var xm = (x[idx - 1] + x[idx] + x[idx + 1]) / 3.0;
            var ym = (y[idx - 1] + y[idx] + y[idx + 1]) / 3.0;
            var n = void 0;
            var z = void 0;
            n = (x[idx - 1] - xm) * (y[idx - 1] - ym);
            n += (x[idx] - xm) * (y[idx] - ym);
            n += (x[idx + 1] - xm) * (y[idx + 1] - ym);
            z = (x[idx - 1] - xm) * (x[idx - 1] - xm);
            z += (x[idx] - xm) * (x[idx] - xm);
            z += (x[idx + 1] - xm) * (x[idx + 1] - xm);
            if (z == 0)
                throw new Error("Derivative: error, some x values are equal");
            d[idx] = n / z;
        }
        return d;
    };
    Derivative.DerivativeEx = function (f) {
        var X = 0;
        var Y = 1;
        if (f.length <= 1)
            throw new Error("Derivative: number of values must be greater than 1");
        var d = [];
        var idx;
        var sz = f.length - 1;
        d[0] = [f[0][X], (f[1][Y] - f[0][Y]) / (f[1][X] - f[0][X])];
        d[sz] = [f[sz][X], (f[sz][Y] - f[sz - 1][Y]) / (f[sz][X] - f[sz - 1][X])];
        for (idx = 1; idx < sz; idx++) {
            var xm = (f[idx - 1][X] + f[idx][X] + f[idx + 1][X]) / 3.0;
            var ym = (f[idx - 1][Y] + f[idx][Y] + f[idx + 1][Y]) / 3.0;
            var n = void 0;
            var z = void 0;
            n = (f[idx - 1][X] - xm) * (f[idx - 1][Y] - ym);
            n += (f[idx][X] - xm) * (f[idx][Y] - ym);
            n += (f[idx + 1][X] - xm) * (f[idx + 1][Y] - ym);
            z = (f[idx - 1][X] - xm) * (f[idx - 1][X] - xm);
            z += (f[idx][X] - xm) * (f[idx][X] - xm);
            z += (f[idx + 1][X] - xm) * (f[idx + 1][X] - xm);
            if (z == 0)
                throw new Error("Derivative: error, some x values are equal");
            d[idx] = [f[idx][X], n / z];
        }
        return d;
    };
    return Derivative;
}());
export { Derivative };
//# sourceMappingURL=Derivative.js.map