export declare class Complex {
    static readonly ZERO: Complex;
    static readonly ONE: Complex;
    static readonly I: Complex;
    static readonly PI: Complex;
    static readonly E: Complex;
    private static readonly EPSILON;
    private _re;
    private _im;
    readonly Real: number;
    readonly Imag: number;
    constructor(re?: number, im?: number);
    static Create(a?: any, b?: any): Complex;
    Set(re: number, im?: number): void;
    Copy(src: Complex): void;
    clone(): any;
    Sign(): void;
    Add(a: Complex): void;
    AddR(a: number): void;
    Sub(a: Complex): void;
    SubR(a: number): void;
    Mul(a: Complex): void;
    MulR(a: number): void;
    Div(a: Complex): void;
    DivR(a: number): void;
    Pow(a: Complex): void;
    Sqrt(): void;
    Exp(): void;
    Log(): void;
    Abs(): number;
    Arg(): number;
    Sin(): void;
    Cos(): void;
    Tan(): void;
    Cot(): void;
    Sec(): void;
    Csc(): void;
    Asin(): void;
    Acos(): void;
    Atan(): void;
    Acot(): void;
    Asec(): void;
    Acsc(): void;
    Sinh(): void;
    Cosh(): void;
    Tanh(): void;
    Coth(): void;
    Csch(): void;
    Sech(): void;
    Asinh(): void;
    Acosh(): void;
    Atanh(): void;
    Acoth(): void;
    Acsch(): void;
    Asech(): void;
    Inverse(): void;
    Conjugate(): void;
    Neg(): void;
    Ceil(places: number): void;
    Floor(places: number): void;
    Round(places: number): void;
    Equals(a: Complex): boolean;
    toString(): string;
    toVector(): number[];
    valueOf(): number;
    isNaN(): boolean;
    private static CoshR;
    private static SinhR;
    private static Hypot;
    private static LogHypot;
    Parse(a: any, b: any): void;
    private ParseString;
}
