var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ControlElement } from "./ControlElement";
import { Complex } from "../Math/Complex";
var ControlElementI = (function (_super) {
    __extends(ControlElementI, _super);
    function ControlElementI(T) {
        var _this = _super.call(this) || this;
        _this._u_sum = 0;
        _this._res = new Complex(0);
        if (T < 0)
            throw new Error("T must be greater then zero!");
        _this._T = T;
        return _this;
    }
    ControlElementI.prototype.GetType = function () {
        return "I";
    };
    ControlElementI.prototype.GetLowestTimeConstant = function () {
        return this._T;
    };
    ControlElementI.prototype.Initialize = function (_dt) {
        this._u_sum = 0;
    };
    ControlElementI.prototype.Calculate = function (u, dt) {
        this._u_sum += u;
        var y = dt * this._u_sum / this._T;
        return y;
    };
    ControlElementI.prototype.TimeFunctionStepResponse = function (t) {
        return t / this._T;
    };
    ControlElementI.prototype.TransferFunction = function (s) {
        this._res.Copy(s);
        this._res.MulR(this._T);
        this._res.Inverse();
        return this._res;
    };
    ControlElementI.prototype.OptimizeGetNumParameters = function () {
        return 1;
    };
    ControlElementI.prototype.OptimizeSetParameters = function (params, startIdx) {
        this._T = params[startIdx + 0];
        if (this._T < 1E-15)
            this._T = 1E-15;
    };
    return ControlElementI;
}(ControlElement));
export { ControlElementI };
//# sourceMappingURL=ControlElementI.js.map