var Gui = (function () {
    function Gui() {
    }
    Gui.GetCheckedRadioValue = function (radioGroupName) {
        var radios = document.getElementsByName(radioGroupName);
        var i;
        for (i = 0; i < radios.length; i++) {
            var r = radios[i];
            if (r.checked)
                return r.value;
        }
        return "";
    };
    Gui.GetComboboxItem = function (inputId) {
        var inputElem = document.getElementById(inputId);
        if (inputElem == null)
            throw new Error("input element not found: " + inputId);
        return inputElem.value;
    };
    Gui.GetString = function (inputId) {
        var inputElem = document.getElementById(inputId);
        if (inputElem == null)
            throw new Error("input element not found: " + inputId);
        return inputElem.value;
    };
    Gui.Set = function (inputId, val) {
        var inputElem = document.getElementById(inputId);
        if (inputElem)
            inputElem.value = val;
    };
    Gui.GetNumber = function (inputId) {
        var inputElem = document.getElementById(inputId);
        if (inputElem == null)
            throw new Error("input element not found: " + inputId);
        if (inputElem.value.length == 0) {
            throw new Error("input value is not a number");
        }
        return Number(inputElem.value);
    };
    Gui.IsChecked = function (inputId) {
        var inputElem = document.getElementById(inputId);
        if (inputElem == null)
            throw new Error("input element not found: " + inputId);
        return inputElem.checked;
    };
    Gui.IsCheckedWithDefault = function (inputId, defaultVal) {
        var inputElem = document.getElementById(inputId);
        if (inputElem == null)
            return defaultVal;
        return inputElem.checked;
    };
    Gui.GetTable = function (tableName) {
        return document.getElementById(tableName);
    };
    Gui.SetTableCell = function (tableName, row, col, val) {
        this.GetTable(tableName).rows[row].cells[col].textContent = val;
    };
    Gui.ClearTable = function (table) {
        var rowIdx;
        for (rowIdx = 1; rowIdx < table.rows.length; rowIdx++) {
            var row = table.rows[rowIdx];
            var colIdx = void 0;
            for (colIdx = 0; colIdx < row.cells.length; colIdx++) {
                row.cells[colIdx].textContent = "";
            }
        }
    };
    Gui.SelectClearOptions = function (selId) {
        var sel = document.getElementById(selId);
        var idx;
        for (idx = sel.options.length - 1; idx >= 0; idx--)
            sel.remove(idx);
    };
    Gui.SelectAddOptions = function (selId, optList) {
        var sel = document.getElementById(selId);
        var idx;
        for (idx = 0; idx < optList.length; idx++) {
            var opt = document.createElement("option");
            opt.innerHTML = optList[idx];
            opt.value = optList[idx];
            sel.appendChild(opt);
        }
    };
    return Gui;
}());
export { Gui };
//# sourceMappingURL=Gui.js.map