const Path = require('path');
const UglifyJsPlugin = require('uglifyjs-webpack-plugin');

module.exports = {

    entry: "./src/ControlAppLoopTuningStepResponse.ts",

    mode: "production",
    //mode: "development",

    output: {
        filename: "bundle.js",
        path: Path.resolve(__dirname, 'dist'),
        libraryTarget: 'var',
        library: 'g'
    },

    resolve: {
        // Add '.ts' and '.tsx' as a resolvable extension.
        extensions: [
            ".tsx", ".ts", ".js"
        ],
        alias: {
            Framework: Path.join(__dirname, "..", "..", "Framework"),
            Libs: Path.join(__dirname, "..", "..", "Libs"),
        },
    },

    module: {
        rules: [{
            test: /\.tsx?$/,
            use: 'ts-loader',
            exclude: /node_modules/
        }]
    },

    optimization: {
        minimizer: [
            new UglifyJsPlugin({
                sourceMap: true
            })
        ]
    }
}