import { ControlElement } from "./ControlElement";
import { Complex } from "../../Framework/Math/Complex";
export declare class ControlLoop extends ControlElement {
    private readonly _controller;
    private readonly _controlPath;
    private _u;
    private _y_n1;
    private _yMin;
    private _yMax;
    private _direction;
    readonly U: number;
    readonly YMin: number;
    readonly YMax: number;
    readonly Amplitude: number;
    constructor(controller: ControlElement, controlPath: ControlElement);
    GetType(): string;
    GetLowestTimeConstant(): number;
    Initialize(dt: number): void;
    Calculate(w: number, dt: number): number;
    TimeFunctionStepResponse(_t: number): number;
    private _res;
    private _tmp;
    TransferFunction(s: Complex): Complex;
    OptimizeGetNumParameters(): number;
    OptimizeSetParameters(params: number[], startIdx: number): void;
}
