var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Gui } from "Framework/Gui/Gui";
import { ControlAppPathStepResponse } from "../../ControlAppPathStepResponse/src/ControlAppPathStepResponse";
import { ControlTools } from "../../shared/ControlTools";
import { ControlPathParamEstimation } from "../../shared/ControlPathParamEstimation";
var ControlAppPathParamEstimation = (function (_super) {
    __extends(ControlAppPathParamEstimation, _super);
    function ControlAppPathParamEstimation() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ControlAppPathParamEstimation.prototype.Init = function () {
        this.ControlAppInit();
    };
    ControlAppPathParamEstimation.prototype.ControlPathEstimateParamsDiffEvo = function () {
        try {
            var maxNumSteps = Gui.GetNumber("MAX_NUM_STEPS");
            var uArr = void 0;
            var yArr = void 0;
            _a = ControlTools.ParseMeasDataString(document.getElementById("MEAS_DATA").textContent), uArr = _a[0], yArr = _a[1];
            var stepHeight = void 0;
            var stepTime = void 0;
            var endTime = void 0;
            _b = ControlTools.CalcStepParams(uArr), stepHeight = _b[0], stepTime = _b[1], endTime = _b[2];
            Gui.Set("STEP_HEIGHT", stepHeight);
            Gui.Set("STEP_TIME", stepTime);
            Gui.Set("END_TIME", endTime);
            var ctrlPath = this.CreateControlPathFromGui();
            var ctrlOpti = new ControlPathParamEstimation(ctrlPath, yArr);
            var minParams = 0;
            var maxParams = 1000;
            var dither = true;
            var params = ctrlOpti.Optimize(minParams, maxParams, dither, maxNumSteps, stepHeight, stepTime);
            this.ShowControlParamsInGui(params);
            Gui.Set("STEP_HEIGHT", stepHeight);
            Gui.Set("STEP_TIME", stepTime);
            Gui.Set("END_TIME", endTime);
            this.ControlPathStepResponse(yArr);
        }
        catch (err) {
            alert(err.message);
        }
        var _a, _b;
    };
    ControlAppPathParamEstimation.prototype.ControlPathEstimateParamsStepResponse = function () {
        try {
            var uArr = void 0;
            var yArr = void 0;
            _a = ControlTools.ParseMeasDataString(document.getElementById("MEAS_DATA").textContent), uArr = _a[0], yArr = _a[1];
            this.ControlPathStepResponse(yArr);
        }
        catch (err) {
            alert(err.message);
        }
        var _a;
    };
    ControlAppPathParamEstimation.Inst = new ControlAppPathParamEstimation();
    return ControlAppPathParamEstimation;
}(ControlAppPathStepResponse));
export { ControlAppPathParamEstimation };
//# sourceMappingURL=ControlAppPathParamEstimation.js.map