/*
    Copyright (C) 2016  Torsten Brischalle
    email: torsten@brischalle.de
    web: http://www.aaabbb.de
    
    MIT License

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.
*/

import { CircuitType } from "./CircuitType";

//-------------------------------------------------------------------------------------------------

export class ResistorCombinationResult
{
    private _r1: number = 0;
    private _r2: number = 0;
    private _res: number = 0;
    private _diff: number = 0;
    private _circuitType: CircuitType = CircuitType.UNDEFINED;

    public get R1(): number { return this._r1; }
    public get R2(): number { return this._r2; }
    public get Res(): number { return this._res; }
    public get Diff(): number { return this._diff; }
    public get CircuitType(): CircuitType { return this._circuitType; }

    public get CircuitTypeStr(): string
    {
        switch (this._circuitType)
        {
            case CircuitType.SERIES:
                return "+";
            case CircuitType.PARALLEL:
                return "||";
            case CircuitType.SINGLE:
                return " ";
            default:
                return "???";
        }
    }

    public constructor(r1: number, r2: number, res: number, diff: number, circuitType: CircuitType)
    {
        this._r1 = r1;
        this._r2 = r2;
        this._res = res;
        this._diff = diff;
        this._circuitType = circuitType;
    }
}

//-------------------------------------------------------------------------------------------------
